summaryrefslogtreecommitdiffstats
path: root/system/iscan/iscan.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/iscan/iscan.SlackBuild')
-rw-r--r--system/iscan/iscan.SlackBuild144
1 files changed, 144 insertions, 0 deletions
diff --git a/system/iscan/iscan.SlackBuild b/system/iscan/iscan.SlackBuild
new file mode 100644
index 0000000000..33276ad0c0
--- /dev/null
+++ b/system/iscan/iscan.SlackBuild
@@ -0,0 +1,144 @@
+#!/bin/sh
+
+# Slackware build script for iscan
+
+# Copyright 2019 Matteo Bernardini <ponce@slackbuilds.org>, Pisa, Italy
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Shamelessly ripped from Alien Bob's script: thank him for all the hard work!
+
+PRGNAM=iscan
+VERSION=${VERSION:-2.30.4}
+ADDVER=${ADDVER:-2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+# Minor library version of libpng on our system:
+PNGMINOR=$(pkg-config --modversion libpng |cut -d'.' -f2)
+if [ $PNGMINOR -gt 5 ]; then
+ PNG_LDFLAGS="-lpng16"
+elif [ $PNGMINOR -eq 4 ]; then
+ PNG_LDFLAGS="-lpng14"
+fi
+
+DOCS="COPYING INSTALL NEWS README non-free/COPYING*.txt"
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/${PRGNAM}_${VERSION}-${ADDVER}.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Apply ArchLinux patches:
+# Allow linking against libpng15 and newer:
+patch -p0 < $CWD/patches/iscan_png15.patch
+# Patch for ambiguous div in jpegstream.cc:
+patch -p0 < $CWD/patches/jpegstream.cc.patch
+# Fix compilation error 'unknown type name u_char' on 32bit:
+patch -p1 < $CWD/patches/iscan-2.30.3_x86-unknown-types.patch
+# Add fix for CXX ABI different than 1002:
+ln -s libesmod-x86_64.c2.so non-free/libesmod-x86_64.so
+
+LDFLAGS="-ldl $PNG_LDFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --enable-dependency-reduction \
+ --enable-frontend \
+ --enable-jpeg \
+ --enable-tiff \
+ --enable-png \
+ --enable-gimp \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+# Install the SANE backend configuration:
+mkdir -p $PKG/etc/sane.d/dll.d
+install -m0644 backend/epkowa.conf $PKG/etc/sane.d/epkowa.conf.new
+echo "epkowa" > $PKG/etc/sane.d/dll.d/epkowa.conf
+
+# Create the forgotten desktop menu:
+mkdir -p $PKG/usr/share/applications
+install -m0644 $PRGNAM.desktop $PKG/usr/share/applications/$PRGNAM.desktop
+
+# Make the GIMP aware of the iscan plugin:
+mkdir -p $PKG/usr/lib$LIBDIRSUFFIX/gimp/2.0/plug-ins
+ln -s /usr/bin/$PRGNAM $PKG/usr/lib$LIBDIRSUFFIX/gimp/2.0/plug-ins/
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}